clear all
clc
close all
%Vzorkování frekvenční charakteristiky
fvz=500;
% signaly=load('signaly_f_ADP9_2.mat');
% signaly=signaly.signaly_f_ADP9_2;
signaly=load('signaly_zkraceno');
signaly=signaly.signaly_zkraceno;

jmena=[];
svody={};
 for i=1:1
x=signaly(i,:);
sig=signaly(i,:); 
x = x - mean(x);
sig=sig- mean(sig);
fvz=500;
n = 1:1:length(x); 
A=50;
brum =A*cos(2*pi*50*n/fvz);

x=x+brum;
x=x-mean(x);
N=500;%počet vzorků impulsní charakteristiky
H=ones(1,500);
onak=0.7;
H(1,51)=0;
H(1,50)=onak;
H(1,52)=onak;

H(1,451)=0;
H(1,450)=onak;
H(1,452)=onak;

 figure(1)
stem(0:N-1,H);
title('vzorkovaná reálná frekvenční charakteristika')
xlabel('f[Hz]')
ylabel('H(k)')
%výpočet impulsní charakteristiky
 g=real(ifft(H));
figure(2)
stem(0:N-1,g,'-');
 title('IFFT realné frekvenční charakteristiky')
% přerovnání impulsní charakterisitky
 h=[g((N+3)/2:end) g(1:(N+1)/2)];
figure(3)
stem(1:N-1,h,'-');
ff=h(h<0.8);
title('impulzní charakteristika')
figure(33)
stem(1:N-2,ff,'-')
title('impulzní charakteristika')
%  % doplnění impulsní charakteristiky nulami
h=h.*hamming(1,length(h));
 figure(4)
hin=abs(fft(h,5000));
plot(hin)
 h=h.*hamming(1,length(h));
Hint=abs(fft(h,5000));
hint=(Hint).^(1/2);
title('impulzní charaktesritika')
figure(4)
f = linspace(0,fvz-(fvz/5000),5000);
plot(f,hint)
title('Amplitudová charakteristika')
xlabel('f[Hz]')
ylabel('H(k)')
 figure(10)
 subplot(2,1,1)
 Y=filtfilt(h,1,x);
 zac=500;
 kon=4500;
plot(Y(1,zac:kon))
hold on 
plot(sig(1,zac:kon))
ylabel('U[\muV]')
  title('filtrovaný a původní signál')
   xlabel('n[-]')
rozdil=[];
for d=1:5000
    rozdil=[rozdil Y(1,d)-sig(1,d)];
end
subplot(2,1,2)
plot(rozdil(1,zac:kon))
 ylabel('U[\muV]')
 title('rozdílový signál')
 xlabel('n[-]')

end
 
